-----------------------------------------------------------------------------------------------
-- Client Lua Script for ShowFPS
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- ShowFPS Module Definition
-----------------------------------------------------------------------------------------------
local ShowFPS = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function ShowFPS:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function ShowFPS:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- ShowFPS OnLoad
-----------------------------------------------------------------------------------------------
function ShowFPS:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("ShowFPS.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- ShowFPS OnDocLoaded
-----------------------------------------------------------------------------------------------
function ShowFPS:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "ShowFPSForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)

		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)
		Apollo.RegisterSlashCommand("showfps", "OnShowFPSOn", self)
		Apollo.RegisterSlashCommand("closefps","OnFpsClose",self)
		Apollo.CreateTimer("FPSTimer", 1.5 , true)
		Apollo.RegisterTimerHandler("FPSTimer","OnShowFPS",self)


		-- Do additional Addon initialization here
	end
end

-----------------------------------------------------------------------------------------------
-- ShowFPS Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-- on SlashCommand "/showfps"
function ShowFPS:OnShowFPSOn()
	self.wndMain:Invoke() -- show the window

	function ShowFPS:OnShowFPS()
	self.wndMain:FindChild("fpscounter"):SetText(GameLib.GetFrameRate())
	
	end	
end
	

function ShowFPS:OnFpsClose()
self.wndMain:Close()
end

    
-----------------------------------------------------------------------------------------------
-- ShowFPS Instance
-----------------------------------------------------------------------------------------------
local ShowFPSInst = ShowFPS:new()
ShowFPSInst:Init()
